﻿cls
write-host "-----------------------------------------------------------------------" -foregroundcolor black -backgroundcolor white
write-host "--------------------PDF > ISBN Extractor Script 0.3--------------------" -foregroundcolor black -backgroundcolor white
write-host "-----------------------------------------------------------------------" -foregroundcolor black -backgroundcolor white

$source = read-host "Source Path?"
$dest= read-host "Destination Path?"
mkdir $dest -Force  | out-null 

write-host "-----------------------------------------------------------------------" -foregroundcolor black -backgroundcolor white
write-host "---------------------------!!!STARTING!!!------------------------------" -foregroundcolor black -backgroundcolor white
write-host "-----------------------------------------------------------------------" -foregroundcolor black -backgroundcolor white

foreach ($file in Get-Childitem $source -Recurse)
{
if ($file.extension -eq ".pdf")
{
$countpdf = $countpdf+1
	$name = ""
write-host "-----------------------------------------------------------------------" -foregroundcolor black
write-host $file.Name
.\pdftotext.exe -q -raw -f 1 -l 10 $file.FullName tmp.txt 
	
     $name = cat tmp.txt | where {$_ -match "^isbn"}

If ($name)
{
#$name
$name = [regex]::replace($name, "," ,"        ")
$name = [regex]::replace($name, "\(" ,"        ")
$name = [regex]::replace($name, ";" ,"        ")
$name = [regex]::replace($name, "©" ,"        ")
$name = [regex]::replace($name, " ISBN" ,"          ")
$name = [regex]::replace($name, " isbn" ,"          ")
$name = [regex]::replace($name, " 1 2 3 4 5" ,"        ")
$name = ("{0,-26}" -f $name).substring(0,26)
$name = [regex]::replace($name, ":" ,"")
$name = [regex]::replace($name, "-" ,"")
$name = [regex]::replace($name, " " ,"")
$name = [regex]::replace($name, "isbn10" ,"")
$name = [regex]::replace($name, "ISBN10" ,"")
$name = [regex]::replace($name, "ISBN13" ,"")
$name = [regex]::replace($name, "isbn13" ,"")
$name = [regex]::replace($name, "isbn" ,"")
$name = [regex]::replace($name, "ISBN" ,"")
$name = [regex]::replace($name, "O" ,"0")
$name = [regex]::replace($name, "[^0-9xX]" ,"") # '^' to negate selection!!
$name = $name.substring(0, [System.Math]::Min(13, $name.Length)) 
}

If ($name.Length -gt 9)
{
cp $file.FullName $dest\$name.pdf
$epub = $file.FullName -replace '\.pdf','.epub' 

If (test-path $epub)
{
$countepub = $countepub+1
$epub
cp $epub $dest\$name.epub
}

write-host "ISBN" $name -foregroundcolor black -backgroundcolor yellow
$countfound = $countfound+1
}

}
}
write-host "-----------------------------------------------------------------------" -foregroundcolor black -backgroundcolor white
write-host "---------------------------!!!FINISHED!!!------------------------------" -foregroundcolor black -backgroundcolor white
write-host "-----------------------------------------------------------------------" -foregroundcolor black -backgroundcolor white
write-host "found" $countfound "ISBN in" $countpdf "PDF files and" $countepub "Epub files"-foregroundcolor black -backgroundcolor white
